package com.example.demo.control;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.example.demo.entity.Data;
import com.example.demo.entity.DataResult;
import com.example.demo.entity.ReturnData;
import com.example.demo.entity.Template;
import com.example.demo.service.DataService;
import com.example.demo.service.TemplateService;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import sun.misc.BASE64Encoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@RestController
public class DataController {

    @Autowired
    private DataService dataService;

    @Autowired
    private TemplateService templateService;

    @RequestMapping(value = "/updateExcelDataALL",method = RequestMethod.POST)
    public ReturnData updateExcelData(String dataList,String deleteList){
        List<DataResult> dataResults = JSON.parseArray(dataList,DataResult.class);
        List<Integer> deletes =  JSON.parseArray(deleteList,Integer.class);
        List<Data> insertList = new ArrayList<>();
        List<Data> updateList = new ArrayList<>();
        dataResults.forEach(e->{
            if (e.getDataId()==null){
                Data data = new Data();
                data.setTemplateId(e.getTemplateId());
                data.setCreatePerson(e.getCreatePerson());
                data.setCreateDate(new Date());
                data.setExcelData(JSON.toJSONString(e.getExcelData()));
                insertList.add(data);
            }else {
                Data data = new Data();
                data.setDataId(e.getDataId());
                data.setTemplateId(e.getTemplateId());
                data.setCreatePerson(e.getCreatePerson());
                data.setCreateDate(new Date());
                data.setExcelData(JSON.toJSONString(e.getExcelData()));
                updateList.add(data);
            }
        });
//        dataService.insertData(insertList);
//        dataService.updateDataList(updateList);
//        dataService.deleteDataList(deletes);
        dataService.updateDataAll(insertList,updateList,deletes);
        return ReturnData.getSuccess(true);
    }

    @RequestMapping(value = "/insertExcelData",method = RequestMethod.POST)
    public ReturnData selectTemplate(String excelData, String templateId, String person){
        JSONArray jsonArray = JSONArray.parseArray(excelData);
        List<Object> list = jsonArray.toJavaList(Object.class);
        List<Data> dataList = new ArrayList<>();
        list.forEach(item -> {
            Data data = new Data();
            data.setTemplateId(templateId);
            data.setCreatePerson(person);
            data.setCreateDate(new Date());
            data.setExcelData(JSON.toJSONString(item));
            dataList.add(data);
        });
        Boolean flag = dataService.insertData(dataList);
//        Data data = new Data();
//        data.setExcelData(excelData);
//        data.setTemplateId(templateId);
//        data.setCreateDate(new Date());
//        Boolean flag = dataService.insertData(data);
        return ReturnData.getSuccess(flag);
    }

    @RequestMapping(value = "/getDataByPerson",method = RequestMethod.POST)
    public ReturnData getDataByPerson(String createPerson,String templateId){
        List<Data> dataList = dataService.selectDataByPerson(createPerson,templateId);
        List<DataResult> dataResults = new ArrayList<>();
        dataList.forEach(e -> {
            DataResult dataResult = new DataResult();
            dataResult.setDataId(e.getDataId());
            dataResult.setCreateDate(e.getCreateDate());
            dataResult.setCreatePerson(e.getCreatePerson());
            dataResult.setTemplateId(e.getTemplateId());
            dataResult.setExcelData(JSON.parse(e.getExcelData()));
            dataResults.add(dataResult);
        });
        return ReturnData.getSuccess(dataResults);
    }

    @RequestMapping(value = "/updateExcelData",method = RequestMethod.POST)
    public Integer updateTemplate(String excelData,String templateId,Integer excelDataId){
        Data data = new Data();
        data.setDataId(excelDataId);
        data.setExcelData(excelData);
        return dataService.updateData(data);
    }

    @RequestMapping(value = "/getExcelData",method = RequestMethod.POST)
    public ReturnData getTemplate(String templateId){
        List<Data> list = dataService.selectDataByTemplateId(templateId);
//        List listAll = new ArrayList();
//        list.forEach(item -> {
//            listAll.addAll(JSONArray.parseArray(item.getExcelData()));
//        });
        return ReturnData.getSuccess(list);
    }

    @RequestMapping(value = "/exportData/{templateId}",method = RequestMethod.GET)
    public void exportData(@PathVariable String templateId, HttpServletResponse response, HttpServletRequest request){
        List<Data> list = dataService.selectDataByTemplateId(templateId);
        Template template = templateService.selectTemplate(templateId);
//        List listAll = new ArrayList();
//        list.forEach(item -> {
//            listAll.addAll(JSONArray.parseArray(item.getExcelData()));
//        });
        HSSFWorkbook wb = this.createExcel(template,list);
        try {
            this.setResponseHeader(response,request, template.getTemplateTitle()+".xls");
            OutputStream os = response.getOutputStream();
            wb.write(os);
            os.flush();
            os.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
//        return ReturnData.getSuccess(list);
    }

    public void setResponseHeader(HttpServletResponse response,HttpServletRequest request, String fileName) {
        try {
            try {
                fileName = new String(fileName.getBytes("utf-8"),"utf-8");
                System.out.println(fileName);
            } catch (UnsupportedEncodingException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
            //获得请求头中的User-Agent
            String agent = request.getHeader("User-Agent");
            //根据不同浏览器进行不同的编码
            String filenameEncoder = "";
            if (agent.contains("MSIE")) {
                // IE浏览器
                filenameEncoder = URLEncoder.encode(fileName, "utf-8");
                filenameEncoder = filenameEncoder.replace("+", " ");
            } else if (agent.contains("Firefox")) {
                // 火狐浏览器
                BASE64Encoder base64Encoder = new BASE64Encoder();
                filenameEncoder = "=?utf-8?B?"
                        + base64Encoder.encode(fileName.getBytes("utf-8")) + "?=";
            } else {
                // 其它浏览器
                filenameEncoder = URLEncoder.encode(fileName, "utf-8");
            }
            response.setContentType("application/octet-stream;charset=ISO8859-1");
            response.setHeader("Content-Disposition", "attachment;filename="+ filenameEncoder );
            response.addHeader("Pargam", "no-cache");
            response.addHeader("Cache-Control", "no-cache");
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private HSSFWorkbook createExcel(Template template,List<Data> dataList){
        HSSFWorkbook workbook = new HSSFWorkbook();
        HSSFSheet sheet = workbook.createSheet(template.getTemplateTitle());
        Row title = sheet.createRow(0);
        int titleLength = template.getTemplateDataList().size();
        for (int i=0;i<titleLength;i++){
            Cell cell = title.createCell(i);
            cell.setCellValue(template.getTemplateDataList().get(i).getRowName());
        }
        int dataLength = dataList.size();
        for (int i=0;i<dataLength;i++){
            Row row = sheet.createRow(i+1);
            Map<String,String> object = JSON.parseObject(dataList.get(i).getExcelData(), Map.class);
            for (int j=0;j<titleLength;j++){
                Cell cell = row.createCell(j);
                cell.setCellValue(object.get(template.getTemplateDataList().get(j).getRowName()));
            }
        }
        return workbook;
    }
}
