package com.example.demo.control;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.example.demo.entity.Data;
import com.example.demo.entity.Template;
import com.example.demo.service.DataService;
import com.example.demo.service.TemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import java.util.ArrayList;
import java.util.List;

@Controller
public class PageController {

    @Autowired
    private TemplateService templateService;

    @Autowired
    private DataService dataService;

    @RequestMapping("/template/list")
    public String templateList(Model model){
        List<Template> templateList = templateService.selectAllTemplate();
        model.addAttribute("templateList", templateList);
        return "template-list";
    }

    @RequestMapping("/template/{id}")
    public String template(@PathVariable String id,Model model){
//        Template template = templateService.selectTemplate(id);
        model.addAttribute("id", id);
        return "template";
    }

    @RequestMapping("/template/update/{id}")
    public String templatedata(@PathVariable String id,Model model){
//        System.out.println(id);
//        Template template = templateService.selectTemplate(id);
//        Data list = dataService.selectDataByDataId(dataId);
//        model.addAttribute("template", template);
//        model.addAttribute("excelDataId", list.getDataId());
//        model.addAttribute("excelData", JSONArray.parseArray(list.getExcelData()));
        return "template-data";
    }

    @RequestMapping("/excel/{templateId}")
    public String excel(@PathVariable String templateId,Model model){
//        Template template = templateService.selectTemplate(templateId);
//        List<Data> list = dataService.selectDataByTemplateId(templateId);
//        List listAll = new ArrayList();
//        list.forEach(item -> {
//            listAll.addAll(JSONArray.parseArray(item.getExcelData()));
//        });
//        model.addAttribute("template", template);
//        model.addAttribute("templateDataList", JSON.toJSONString(template.getTemplateDataList()));
//        model.addAttribute("excelData", listAll);
        model.addAttribute("templateId", templateId);
        return "excel";
    }

    @RequestMapping("/")
    public String index(Model model){
        return "redirect:/addTemplate";
    }

    @RequestMapping("/addTemplate")
    public String template(Model model){
        return "add_template";
    }

    @RequestMapping("/result/{templateId}/{flag}")
    public String result(@PathVariable String templateId,@PathVariable Boolean flag,Model model){
//        Template template = templateService.selectTemplate(templateId);
//        Data list = dataService.selectDataByDataId(dataId);
        model.addAttribute("flag",flag);
        if (flag){
            model.addAttribute("result","数据提交成功！");
            model.addAttribute("templateId",templateId);
        }else{
            model.addAttribute("result","数据提交失败！");
        }
        return "result";
    }

}
