package com.example.demo.control;

import com.alibaba.fastjson.JSONArray;
import com.example.demo.entity.ReturnData;
import com.example.demo.entity.Template;
import com.example.demo.entity.TemplateData;
import com.example.demo.service.TemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;

@RestController
public class TemplateController {

    @Autowired
    private TemplateService templateService;

    @RequestMapping(value = "/getTemplateById/{id}",method = RequestMethod.GET)
    public ReturnData selectTemplate(@PathVariable String id){
        return ReturnData.getSuccess(templateService.selectTemplate(id));
    }

    @RequestMapping(value = "/insertTemplate",method = RequestMethod.POST)
    public ReturnData insertTemplate(String templateData,String tableName,String person){
        JSONArray array = JSONArray.parseArray(templateData);
        List<TemplateData> list = array.toJavaList(TemplateData.class);
        System.out.println(list.toString());
        System.out.println(tableName);

        Template template = new Template();
        template.setTemplateId(tableName);
        template.setTemplateTitle(tableName);
        template.setCreateDate(new Date());
        template.setCreatePerson(person);
        Template tem = templateService.insertTemplate(template,list);
        if (tem == null){
            return ReturnData.getError();
        }
        return ReturnData.getSuccess(tem.getTemplateId().toString());
    }

    @RequestMapping(value = "/getTemplateList",method = RequestMethod.GET)
    public ReturnData selectTemplate(){
        return  ReturnData.getSuccess(templateService.selectAllTemplate());
    }
}
