package com.example.demo.service.impl;

import com.example.demo.dao.DataMapper;
import com.example.demo.entity.Data;
import com.example.demo.service.DataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class DataServiceImpl implements DataService {

    @Autowired
    private DataMapper dataMapper;

    @Override
    public Boolean insertData(List<Data> dataList){
        Integer num = dataMapper.insertDataList(dataList);
        return num >= dataList.size();
    }

    @Override
    public Boolean insertData(Data data){
        Integer num = dataMapper.insertData(data);
        return num >= 1;
    }

    @Override
    public Integer updateData(Data data) {
        return dataMapper.updateData(data);
    }

    @Override
    public Integer updateDataList(List<Data> dataList) {
        return dataMapper.updateDataList(dataList);
    }

    @Override
    public List<Data> selectDataByTemplateId(String templateId){
        return dataMapper.selectDataByTemplateId(templateId);
    }

    @Override
    public List<Data> selectDataByPerson(String createPerson,String templateId){
        return dataMapper.selectDataByPerson(createPerson,templateId);
    }

    @Override
    public Data selectDataByDataId(Integer dataId) {
        return dataMapper.selectDataByDataId(dataId);
    }

    @Override
    public Integer deleteDataList(List<Integer> list) {
        return dataMapper.deleteDataList(list);
    }

    @Transactional
    @Override
    public void updateDataAll(List<Data> insertList, List<Data> updateList, List<Integer> deletes) {
        if (insertList.size()>0)
        this.insertData(insertList);
        if (updateList.size()>0)
        this.updateDataList(updateList);
        if (deletes.size()>0)
        this.deleteDataList(deletes);
    }
}
