package com.example.demo.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.example.demo.dao.TemplateDataMapper;
import com.example.demo.dao.TemplateMapper;
import com.example.demo.entity.Template;
import com.example.demo.entity.TemplateData;
import com.example.demo.service.TemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class TemplateServiceImpl implements TemplateService{

    @Autowired(required = false)
    private TemplateMapper templateMapper;

    @Autowired(required = false)
    private TemplateDataMapper templateDataMapper;

    @Override
    public Template selectTemplate(String id){
        System.out.println("id:"+id);
        Template e = templateMapper.selectTemplate(id);
        System.out.println(e.toString());
        List<TemplateData> list = templateDataMapper.selectTemplateData(id);
        list.forEach(item -> {
            item.setJsonObj(JSONObject.parse(item.getFlagValue()));
        });
        e.setTemplateDataList(list);
        System.out.println(list.toString());
        return e;
    }

    @Override
    public List<Template> selectAllTemplate() {
        return templateMapper.selectAllTemplate();
    }

    @Override
    public Template insertTemplate(Template template, List<TemplateData> list) {
        Template tem = templateMapper.selectTemplate(template.getTemplateId());
        if (tem!=null){
            return null;
        }
        int num = templateMapper.insertTemplate(template);
        System.out.println(template.getTemplateId());
        list.forEach(item -> {
            item.setTemplateId(template.getTemplateId());
        });
        System.out.println(list.toString());
        templateDataMapper.insertTemplateDataList(list);
        return template;
    }
}
