new Vue({
    el: '#container',
    data() {
        return{
            formName:'',
            checkedAll: false,
            typeList:[
                {
                    name:'文本',
                    value: 'text'
                },
                {
                    name: '数字',
                    value: 'numeric'
                },
                {
                    name: '下拉选',
                    value: 'dropdown'
                },
                {
                    name: '时间',
                    value: 'calendar'
                }
            ],
            calendarList:[
                {
                    name:'年-月-日 时:分',
                    value: 'yyyy-MM-dd HH:mm'
                },
                {
                    name:'年-月-日',
                    value: 'yyyy-MM-dd'
                },
                {
                    name:'月-日',
                    value: 'MM-dd'
                },
                {
                    name:'时:分',
                    value: 'HH:mm'
                },
                {
                    name:'自定义',
                    value: 'orderByMe'
                }
            ],
            dataList:[
                {
                    rowName:'',
                    type: 'text',
                    timeFormat:'',
                    flagValue:[]
                }
            ]
        }
    },
    methods: {
        selectAll(){
            this.dataList.forEach((e,index)=>{
                e.checked = this.checkedAll
                this.$set(this.dataList,index,e);
            })
        },
        isCheckAll(){
            var checkall = true
            this.dataList.forEach((e,index)=>{
                if(!e.checked){
                    checkall = false
                }
            })
            this.checkedAll = checkall
        },
        changeFlagValueStatus(data,index,flag){
            data.flagValueStatus = flag
            this.$set(this.dataList, index, data);
            if(data.flagValueStatus){
                this.$nextTick(()=>{
                    this.$refs[`editLabelInput-${index}`][0].focus()
                })
            }
        },
        addFlagValueStatus(data,index){
            if(!data.addFlagValue){
                this.changeFlagValueStatus(data,index,false)
                return;
            }
            data.flagValue.push(data.addFlagValue)
            data.addFlagValue = ""
            this.changeFlagValueStatus(data,index,false)
        },
        resetFlagValueStatus(data,index){
            data.flagValue = []
            this.changeFlagValueStatus(data,index,false)
        },
        addTemplate(){
            var obj = {
                rowName:'',
                type: 'text',
                timeFormat:'',
                flagValue:[]
            }
            if(this.checkedAll){
                obj.checked = true
            }
            this.dataList.push(obj)
        },
        deleteTemplate(){
            this.dataList = this.dataList.filter((e,index)=> {
                return !e.checked
            })
        },
        submitData(){
            let params = new FormData()
            params.append('templateData',JSON.stringify(this.dataList))
            params.append('tableName',this.formName)
            params.append('person',this.cans())
            axios.post(ctxPath+'insertTemplate',params)
                .then(response => {
                    if(response.data.code == '0000'){
                        location.href= ctxPath+'template/'+response.data.data
                    }else{
                        alert("表单名已存在！")
                    }
                })
                .catch((error) => { // 请求失败处理
                    console.log(error);
                });
        },
        cans() {
            var canvas = document.createElement('canvas');
            var ctx = canvas.getContext('2d');
            var txt = 'http://www.aiipu.com/';
            ctx.textBaseline = "top";
            ctx.font = "14px 'Arial'";
            ctx.textBaseline = "ipu";
            ctx.fillStyle = "#f60";
            ctx.fillRect(125, 1, 62, 20);
            ctx.fillStyle = "#069";
            ctx.fillText(txt, 2, 15);
            ctx.fillStyle = "rgba(102, 204, 0, 0.7)";
            ctx.fillText(txt, 4, 17);
            var b64 = canvas.toDataURL().replace("data:image/png;base64,", "");
            var bin = atob(b64);
            var crc = this.bin2hex(bin.slice(-16, -12));
            //var crc = bin.slice(-16,-12);
            return crc;
        },
        bin2hex(str) {
            var result = "";
            for (i = 0; i < str.length; i++) {
                result += this.int16_to_hex(str.charCodeAt(i));
            }
            return result;
        },
        int16_to_hex(i) {
            var result = i.toString(16);
            var j = 0;
            while (j + result.length < 4) {
                result = "0" + result;
                j++;
            }
            return result;
        }
    }
})