new Vue({
  el: '#container',
  data() {
    return {
        templateId: '',
        responseData: {},
        checkedAll: false,
        dataList:[],
        checkedList:[false],
        dataTemplate:{},
    }
  },
    watch:{
        dataList(val){
            console.log(val);
            console.log(this.dataList);
        }
    },
  mounted() {
    this.templateId = document.getElementById("templateId").value
    axios.get(ctxPath+'getTemplateById/'+this.templateId)
        .then(response => {
            console.log(response)
            if(response.data.code == '0000'){
                this.responseData = response.data.data
                var dataTemplate = {}
                response.data.data.templateDataList.forEach(e=>{
                    dataTemplate[e.rowName] = ''
                })
                this.dataList.push(dataTemplate)
            }else{
                alert("请求错误！")
            }

        })
        .catch((error) => { // 请求失败处理
          console.log(error);
        });


  },
    methods:{
        showDate(e,item,obj,key){
            var formatstr = item.timeFormat;
            var type = 'date';
            var yearflag = formatstr.indexOf('yyyy')!=-1;
            var monthflag = formatstr.indexOf('MM')!=-1;
            var dayflag = formatstr.indexOf('dd')!=-1;
            var hourflag = formatstr.indexOf('HH')!=-1;
            var minflag = formatstr.indexOf('mm')!=-1;
            if(formatstr == 'yyyy'){
                type = 'year'
            }else if(yearflag&&monthflag&&!dayflag&&!hourflag&&!minflag){
                type = 'month'
            }else if(yearflag&&monthflag&&dayflag&&!hourflag&&!minflag){
                type = 'date'
            }else if(!yearflag&&!monthflag&&!dayflag&&hourflag&&minflag){
                type = 'time'
            }else{
                type = 'datetime'
            }
            console.log(e)
            laydate.render({
                elem: e.srcElement
                ,type: type,
                format:formatstr,
                show: true,
                done: (value, date, endDate) =>{
                    e.srcElement.value = value
                    obj[key] = value
                }
            });
        },
        selectAll(){
            this.checkedList.forEach((e,index)=>{
                e = this.checkedAll
                this.$set(this.checkedList,index,e);
            })
        },
        isCheckAll(){
            var checkall = true
            this.checkedList.forEach((e,index)=>{
                if(!e){
                    checkall = false
                }
            })
            this.checkedAll = checkall
        },
        changeDataList(dataKey,templateKey){
            console.log(dataKey,templateKey)
        },
        addTemplate(){
            console.log(this.dataTemplate)
            var dataTemplate = {}
            this.responseData.templateDataList.forEach(e=>{
                dataTemplate[e.rowName] = ''
            })
            if(this.checkedAll){
                this.checkedList.push(true)
            }else{
                this.checkedList.push(false)
            }
            this.dataList.push(dataTemplate)
        },
        deleteTemplate(){
            this.dataList = this.dataList.filter((e,index)=> {
                return !this.checkedList[index]
            })
            this.checkedList = this.checkedList.filter((e,index)=> {
                return !e
            })
        },
        submitData(){
            console.log(this.dataList);
            let params = new FormData()
            params.append('excelData',JSON.stringify(this.dataList))
            params.append('templateId',this.templateId)
            params.append('person',this.cans())
            axios.post(ctxPath+'insertExcelData',params).then(response => {
                if(response.data.code == '0000'){
                    location.href= ctxPath+"result/"+this.templateId+"/"+response.data.data;
                }else{
                    alert('提交错误！')
                }
            })
            .catch((error) => { // 请求失败处理
                console.log(error);
            });
        },
        copy(){
            var curWWWPath = window.document.location.href;
            var pathname = window.document.location.pathname;
            var pos = curWWWPath.indexOf(pathname);
            var localhostPath = curWWWPath.substring( 0, pos );
            this.copyText(encodeURI(localhostPath+ctxPath+'template/'+this.templateId),function (){console.log('复制成功')})
        },
        copyText(text, callback){ // text: 要复制的内容， callback: 回调
            var tag = document.createElement('input');
            tag.setAttribute('id', 'cp_hgz_input');
            tag.value = text;
            document.getElementsByTagName('body')[0].appendChild(tag);
            document.getElementById('cp_hgz_input').select();
            document.execCommand('copy');
            document.getElementById('cp_hgz_input').remove();
            if(callback) {callback(text)}
        },
        cans() {
            var canvas = document.createElement('canvas');
            var ctx = canvas.getContext('2d');
            var txt = 'http://www.aiipu.com/';
            ctx.textBaseline = "top";
            ctx.font = "14px 'Arial'";
            ctx.textBaseline = "ipu";
            ctx.fillStyle = "#f60";
            ctx.fillRect(125, 1, 62, 20);
            ctx.fillStyle = "#069";
            ctx.fillText(txt, 2, 15);
            ctx.fillStyle = "rgba(102, 204, 0, 0.7)";
            ctx.fillText(txt, 4, 17);
            var b64 = canvas.toDataURL().replace("data:image/png;base64,", "");
            var bin = atob(b64);
            var crc = this.bin2hex(bin.slice(-16, -12));
            //var crc = bin.slice(-16,-12);
            return crc;
        },
        bin2hex(str) {
            var result = "";
            for (i = 0; i < str.length; i++) {
                result += this.int16_to_hex(str.charCodeAt(i));
            }
            return result;
        },
        int16_to_hex(i) {
            var result = i.toString(16);
            var j = 0;
            while (j + result.length < 4) {
                result = "0" + result;
                j++;
            }
            return result;
        }
    }
})